

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Poppler.Structs.ActionJavascript
    ( 

-- * Exported types
    ActionJavascript(..)                    ,
    newZeroActionJavascript                 ,
    noActionJavascript                      ,


 -- * Properties
-- ** script #attr:script#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionJavascript_script                 ,
#endif
    clearActionJavascriptScript             ,
    getActionJavascriptScript               ,
    setActionJavascriptScript               ,


-- ** title #attr:title#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionJavascript_title                  ,
#endif
    clearActionJavascriptTitle              ,
    getActionJavascriptTitle                ,
    setActionJavascriptTitle                ,


-- ** type #attr:type#
{- | /No description available in the introspection data./
-}
#if ENABLE_OVERLOADING
    actionJavascript_type                   ,
#endif
    getActionJavascriptType                 ,
    setActionJavascriptType                 ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import {-# SOURCE #-} qualified GI.Poppler.Enums as Poppler.Enums

-- | Memory-managed wrapper type.
newtype ActionJavascript = ActionJavascript (ManagedPtr ActionJavascript)
instance WrappedPtr ActionJavascript where
    wrappedPtrCalloc = callocBytes 24
    wrappedPtrCopy = \p -> withManagedPtr p (copyBytes 24 >=> wrapPtr ActionJavascript)
    wrappedPtrFree = Just ptr_to_g_free

-- | Construct a `ActionJavascript` struct initialized to zero.
newZeroActionJavascript :: MonadIO m => m ActionJavascript
newZeroActionJavascript = liftIO $ wrappedPtrCalloc >>= wrapPtr ActionJavascript

instance tag ~ 'AttrSet => Constructible ActionJavascript tag where
    new _ attrs = do
        o <- newZeroActionJavascript
        GI.Attributes.set o attrs
        return o


-- | A convenience alias for `Nothing` :: `Maybe` `ActionJavascript`.
noActionJavascript :: Maybe ActionJavascript
noActionJavascript = Nothing

{- |
Get the value of the “@type@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionJavascript #type
@
-}
getActionJavascriptType :: MonadIO m => ActionJavascript -> m Poppler.Enums.ActionType
getActionJavascriptType s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

{- |
Set the value of the “@type@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionJavascript [ #type 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionJavascriptType :: MonadIO m => ActionJavascript -> Poppler.Enums.ActionType -> m ()
setActionJavascriptType s val = liftIO $ withManagedPtr s $ \ptr -> do
    let val' = (fromIntegral . fromEnum) val
    poke (ptr `plusPtr` 0) (val' :: CUInt)

#if ENABLE_OVERLOADING
data ActionJavascriptTypeFieldInfo
instance AttrInfo ActionJavascriptTypeFieldInfo where
    type AttrAllowedOps ActionJavascriptTypeFieldInfo = '[ 'AttrSet, 'AttrGet]
    type AttrSetTypeConstraint ActionJavascriptTypeFieldInfo = (~) Poppler.Enums.ActionType
    type AttrBaseTypeConstraint ActionJavascriptTypeFieldInfo = (~) ActionJavascript
    type AttrGetType ActionJavascriptTypeFieldInfo = Poppler.Enums.ActionType
    type AttrLabel ActionJavascriptTypeFieldInfo = "type"
    type AttrOrigin ActionJavascriptTypeFieldInfo = ActionJavascript
    attrGet _ = getActionJavascriptType
    attrSet _ = setActionJavascriptType
    attrConstruct = undefined
    attrClear _ = undefined

actionJavascript_type :: AttrLabelProxy "type"
actionJavascript_type = AttrLabelProxy

#endif


{- |
Get the value of the “@title@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionJavascript #title
@
-}
getActionJavascriptTitle :: MonadIO m => ActionJavascript -> m (Maybe T.Text)
getActionJavascriptTitle s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO CString
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- cstringToText val'
        return val''
    return result

{- |
Set the value of the “@title@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionJavascript [ #title 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionJavascriptTitle :: MonadIO m => ActionJavascript -> CString -> m ()
setActionJavascriptTitle s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (val :: CString)

{- |
Set the value of the “@title@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #title
@
-}
clearActionJavascriptTitle :: MonadIO m => ActionJavascript -> m ()
clearActionJavascriptTitle s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 8) (FP.nullPtr :: CString)

#if ENABLE_OVERLOADING
data ActionJavascriptTitleFieldInfo
instance AttrInfo ActionJavascriptTitleFieldInfo where
    type AttrAllowedOps ActionJavascriptTitleFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint ActionJavascriptTitleFieldInfo = (~) CString
    type AttrBaseTypeConstraint ActionJavascriptTitleFieldInfo = (~) ActionJavascript
    type AttrGetType ActionJavascriptTitleFieldInfo = Maybe T.Text
    type AttrLabel ActionJavascriptTitleFieldInfo = "title"
    type AttrOrigin ActionJavascriptTitleFieldInfo = ActionJavascript
    attrGet _ = getActionJavascriptTitle
    attrSet _ = setActionJavascriptTitle
    attrConstruct = undefined
    attrClear _ = clearActionJavascriptTitle

actionJavascript_title :: AttrLabelProxy "title"
actionJavascript_title = AttrLabelProxy

#endif


{- |
Get the value of the “@script@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' actionJavascript #script
@
-}
getActionJavascriptScript :: MonadIO m => ActionJavascript -> m (Maybe T.Text)
getActionJavascriptScript s = liftIO $ withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO CString
    result <- SP.convertIfNonNull val $ \val' -> do
        val'' <- cstringToText val'
        return val''
    return result

{- |
Set the value of the “@script@” field.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' actionJavascript [ #script 'Data.GI.Base.Attributes.:=' value ]
@
-}
setActionJavascriptScript :: MonadIO m => ActionJavascript -> CString -> m ()
setActionJavascriptScript s val = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 16) (val :: CString)

{- |
Set the value of the “@script@” field to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #script
@
-}
clearActionJavascriptScript :: MonadIO m => ActionJavascript -> m ()
clearActionJavascriptScript s = liftIO $ withManagedPtr s $ \ptr -> do
    poke (ptr `plusPtr` 16) (FP.nullPtr :: CString)

#if ENABLE_OVERLOADING
data ActionJavascriptScriptFieldInfo
instance AttrInfo ActionJavascriptScriptFieldInfo where
    type AttrAllowedOps ActionJavascriptScriptFieldInfo = '[ 'AttrSet, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint ActionJavascriptScriptFieldInfo = (~) CString
    type AttrBaseTypeConstraint ActionJavascriptScriptFieldInfo = (~) ActionJavascript
    type AttrGetType ActionJavascriptScriptFieldInfo = Maybe T.Text
    type AttrLabel ActionJavascriptScriptFieldInfo = "script"
    type AttrOrigin ActionJavascriptScriptFieldInfo = ActionJavascript
    attrGet _ = getActionJavascriptScript
    attrSet _ = setActionJavascriptScript
    attrConstruct = undefined
    attrClear _ = clearActionJavascriptScript

actionJavascript_script :: AttrLabelProxy "script"
actionJavascript_script = AttrLabelProxy

#endif



#if ENABLE_OVERLOADING
instance O.HasAttributeList ActionJavascript
type instance O.AttributeList ActionJavascript = ActionJavascriptAttributeList
type ActionJavascriptAttributeList = ('[ '("type", ActionJavascriptTypeFieldInfo), '("title", ActionJavascriptTitleFieldInfo), '("script", ActionJavascriptScriptFieldInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
type family ResolveActionJavascriptMethod (t :: Symbol) (o :: *) :: * where
    ResolveActionJavascriptMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveActionJavascriptMethod t ActionJavascript, O.MethodInfo info ActionJavascript p) => OL.IsLabel t (ActionJavascript -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


